package kGLModel;

import javax.media.opengl.GL;

/**
 * ȒPȌݒpNX
 * @author kei
 *
 */
public class KGLLight {
	/**
	 * OpenGLR}hQJvZNX
	 * (JOGL)
	 */
	private GL gl;

	/**
	 * ̈ʒu
	 */
	public KGLPoint pos = null ;
	/**
	 * ̊gU
	 */
	public KGLPoint dif = null;
	/**
	 * ̋ʌ
	 */
	public KGLPoint spec = null;
	/**
	 * ̊
	 */
	public KGLPoint amb = null;
	/**
	 * ̒liGL_LIGHT0`GL_LIGHT7j
	 */
	private int unit = 0 ;
	/**
	 * ̔ԍi0`7j
	 */
	private int unit_number = 0 ;
	/**
	 * RXgN^<br>
	 * ̏ݒ肷
	 * @param in_gl		OpenGLR}hQJvZNX
	 * @param lightUnit	̒liGL_LIGHT0`GL_LIGHT7j
	 * @param x			̈ʒu(X)
	 * @param y			̈ʒu(Y)
	 * @param z			̈ʒu(Z)
	 * @param r			̐F(R)
	 * @param g			̐F(G)
	 * @param b			̐F(B)
	 */
	public KGLLight(GL in_gl,int lightUnit,float x,float y,float z,float r,float g,float b) {
		gl = in_gl ;
		float[] p = new float[4] ;
		p[0] = x ;
		p[1] = y ;
		p[2] = z ;
		p[3] = 0.0f ;
		setUnit(lightUnit) ;
		pos = KGLPoint.create(p) ;
		dif = KGLPoint.createCOLOR(r,g,b,1.0f) ;
		spec = KGLPoint.createCOLOR(0.5f,0.5f,0.5f,1.0f) ;
		amb = KGLPoint.createCOLOR(0.0f,0.0f,0.0f,1.0f) ;
 	}
	/**
	 * 
	 */
	public void on() {
		gl.glEnable(unit) ;
    	gl.glLightfv(unit,GL.GL_DIFFUSE,dif.getData(),0) ;
    	gl.glLightfv(unit,GL.GL_SPECULAR,spec.getData(),0) ;
    	gl.glLightfv(unit,GL.GL_AMBIENT,amb.getData(),0) ;
    	gl.glLightfv(unit,GL.GL_POSITION,pos.getData(),0) ;
		gl.glEnable(GL.GL_LIGHTING) ;
	}
	/**
	 * 
	 *
	 */
	public void off() {
		gl.glDisable(unit) ;
		gl.glDisable(GL.GL_LIGHTING) ;
		
	}
	/**
	 * gpĂ̒liGL_LIGHT0`GL_LIGHT7j̎o
	 * @return	̒liGL_LIGHT0`GL_LIGHT7j
	 */
	public int getUnit() {
		return unit;
	}
	/**
	 * gpݒ
	 * @param unit	̒liGL_LIGHT0`GL_LIGHT7j
	 */
	public void setUnit(int unit) {
		this.unit = unit;
		if( unit == GL.GL_LIGHT0 ) unit_number = 0 ;
		if( unit == GL.GL_LIGHT1 ) unit_number = 1 ;
		if( unit == GL.GL_LIGHT2 ) unit_number = 2 ;
		if( unit == GL.GL_LIGHT3 ) unit_number = 3 ;
		if( unit == GL.GL_LIGHT4 ) unit_number = 4 ;
		if( unit == GL.GL_LIGHT5 ) unit_number = 5 ;
		if( unit == GL.GL_LIGHT6 ) unit_number = 6 ;
	}
	/**
	 * gpĂԍi0`7j̎o
	 * @return	ԍi0`7j
	 */
	public int getUnit_number() {
		return unit_number;
	}
	/**
	 * gpݒ
	 * @param unit_number	ԍi0`7j
	 */
	public void setUnit_number(int unit_number) {
		this.unit_number = unit_number;
		if( unit_number == 0 ) unit = GL.GL_LIGHT0 ;
		if( unit_number == 1 ) unit = GL.GL_LIGHT1 ;
		if( unit_number == 2 ) unit = GL.GL_LIGHT2 ;
		if( unit_number == 3 ) unit = GL.GL_LIGHT3 ;
		if( unit_number == 4 ) unit = GL.GL_LIGHT4 ;
		if( unit_number == 5 ) unit = GL.GL_LIGHT5 ;
		if( unit_number == 6 ) unit = GL.GL_LIGHT6 ;
		if( unit_number == 7 ) unit = GL.GL_LIGHT7 ;
	}
}
