package kGLModel;
import java.io.* ;
import java.nio.*;
import java.net.URL ;


import javax.media.opengl.GL;
//import com.sun.opengl.util.texture.*;
/**
 * JOGLgpăt@C烂ff[^̓ǂݍ݂ƕ`s<br>
 * gpClear()Ăł<br>
 * nfk֓o^\[X̉܂B<br>
 * 
 * @author kei
 */
public class KGLModelData {
	/**
	 * OpenGLR}hQJvZNX
	 * (JOGL)
	 */
	protected GL gl;
	/**
	 * eNX`ǗNX
	 */
	protected KGLTextures texPool  = null ;
	/**
	 * eNX`ǗNX̃NXō쐬ǂ
	 */
	protected boolean isMakeTexPool = false ;
	/**
	 * ff[^̍̍Œl_ɕ␳邩ǂ
	 */
	protected boolean isUpperGround = false ; 
	/**
	 * VBOi_zobt@jgp邩ǂ
	 */
	protected boolean isUseVBO = false ; 
	/**
	 * \ʂ̐ݒ
	 */
	protected int	frontFace = -1 ;
	
	/**
	 * Wn
	 */
	protected KGLCoordinates coordinates = null ;
	/**
	 * f̒_̍Œl
	 */
	protected KGLPoint minPos = null ;
	/**
	 * f̒_̍ŏl
	 */
	protected KGLPoint maxPos = null ;
	/**
	 * }eA̕`
	 * @author kkoni
	 *
	 */
	protected class GLMaterial {
		/**
		 * }eA
		 */
		String name ;
		/**
		 * `L<br>
		 */
		boolean isVisible = true;
		/**
		 * F
		 */
		float[]	color = null ;
		/**
		 * gU
		 */
		float[]	dif = null ;
		/**
		 * 
		 */
		float[]	amb = null ;
		/**
		 * ˋPx
		 */
		float[]	emi = null ;
		/**
		 * ʔ
		 */
		float[]	spc = null ;
		/**
		 * ʔˋx
		 */
		float[] power = null;
		
		/**
		 * VF[fBO[h<br>
		 * GL_SMOOTH or GL_FLAT
		 */
		boolean shadeMode_IsSmooth = true ; //OpenGL̃ftHgGL_SMOOTH

		/**
		 * _
		 */
		int vertex_num ;
		/**
		 * eNX`hcigp̏ꍇOj<br>
		 */
		int	texID ;
		/**
		 * f[^i[`<br>
		 * GL_N3F_V3F or GL_T2F_C4F_N3F_V3F or GL_T2F_N3F_V3F or GL_C4F_N3F_V3F
		 */
		int interleaveFormat ;
		/**
		 * f[^i[`ɍ킹Ċi[f[^
		 */
		ByteBuffer interleaved = null ;
	}
	/**
	 * f̊eIuWFNgێNX
	 * @author kei
	 *
	 */
	protected class GLObject {
		/**
		 * IuWFNg<br>
		 */
		String name = null ;
		/**
		 * `L<br>
		 */
		boolean isVisible = true;
		/**
		 * }eA̕`<br>
		 */
		GLMaterial[] mat = null ;
		/**
		 * nfk֓o^_zobt@hc<br>
		 * i_zobt@gpꍇɂl͓Ȃj<br>
		 */
		int[] VBO_ids = null ;
		/**
		 * IuWFNg̒_̍ŏl
		 */
		KGLPoint minPos = null ;
		/**
		 * IuWFNg̒_̍ől
		 */
		KGLPoint maxPos = null ;
	}
	/**
	 * `pf[^
	 */
	protected GLObject[] glObj ;
	/**
	 * t@C̊gqēǂݍ݃NX쐬B<br>
	 * MQOt@CĂȂǂˁI<br>
	 * 
	 * @param in_gl		OpenGLR}hQJvZNX
	 * @param in_texPool	eNX`ǗNXinullȂ炱̃NXɍ쐬j
	 * @param dataFile		t@C
	 * @param scale		f̔{
	 * @param in_coordinates	\WNX
	 * @param in_isUpperGround	ff[^̍̍Œl_ɕ␳邩ǂ
	 * @param in_isUseVBO		_zobt@gp邩ǂ
	 * @return	ff[^NX
	 * @throws KGLException
	 */
	static public KGLModelData createGLModel(
			GL in_gl,KGLTextures in_texPool,File dataFile,float scale,KGLCoordinates in_coordinates,
			boolean in_isUpperGround,boolean in_isUseVBO) throws KGLException {
		String name = dataFile.getName() ;
		int p = name.lastIndexOf(".") ;
		if( p == -1 ) return null ;
		String suffix = name.substring(p+1,name.length()).toUpperCase() ;
		if( suffix.equals("MQO") ) return new KGLMetaseq(in_gl,in_texPool,dataFile,scale,in_coordinates,in_isUpperGround,in_isUseVBO) ;
		return null ;
	}
	/**
	 * t@C̊gqēǂݍ݃NX쐬B<br>
	 * MQOt@CĂȂǂˁI<br>
	 * 
	 * @param in_gl		OpenGLR}hQJvZNX
	 * @param in_texPool	eNX`ǗNXinullȂ炱̃NXɍ쐬j
	 * @param dataFile		URL
	 * @param scale		f̔{
	 * @param in_coordinates	\WNX
	 * @param in_isUpperGround	ff[^̍̍Œl_ɕ␳邩ǂ
	 * @param in_isUseVBO		_zobt@gp邩ǂ
	 * @return	ff[^NX
	 * @throws KGLException
	 */
	static public KGLModelData createGLModel(
			GL in_gl,KGLTextures in_texPool,URL dataFile,float scale,KGLCoordinates in_coordinates,
			boolean in_isUpperGround,boolean in_isUseVBO) throws KGLException {
		String name = dataFile.getFile() ;
		int p = name.lastIndexOf(".") ;
		if( p == -1 ) return null ;
		String suffix = name.substring(p+1,name.length()).toUpperCase() ;
		if( suffix.equals("MQO") ) return new KGLMetaseq(in_gl,in_texPool,dataFile,scale,in_coordinates,in_isUpperGround,in_isUseVBO) ;
		return null ;
	}
	/**
	 * nfk֓o^\[X<br>
	 *
	 */
	public void Clear() {
		if( glObj == null ) return ;
		for( int o = 0 ; o < glObj.length ; o++ ) {
			if(glObj[o].VBO_ids != null ) 
				gl.glDeleteBuffersARB(glObj[o].VBO_ids.length,glObj[o].VBO_ids,0) ;
		}
		glObj = null ;
		if( isMakeTexPool ) {
			texPool.Clear() ;
			texPool = null ;
		}
	}
	/**
	 * RXgN^
	 * createGLModelgpăCX^X̂ŁAgpȂB
	 * @param in_gl		OpenGLR}hQJvZNX
	 * @param in_texPool	eNX`ǗNXinullȂ炱̃NXɍ쐬j
	 * @param scale		f̔{
	 * @param in_coordinates	\WNX
	 * @param in_isUpperGround	ff[^̍̍Œl_ɕ␳邩ǂ
	 * @param in_isUseVBO		_zobt@gp邩ǂ
	 */
	protected KGLModelData(GL in_gl,KGLTextures in_texPool,float scale,KGLCoordinates in_coordinates,
			boolean in_isUpperGround,boolean in_isUseVBO) {
		gl = in_gl ;
		texPool = in_texPool ;
		isUseVBO = in_isUseVBO ;
		isUpperGround = in_isUpperGround ;
		coordinates = in_coordinates ;
		frontFace = GL.GL_CCW ;//OpenGL̃ftHgi\ʂ݂т͍j
		if( in_coordinates == null ) {
			coordinates = new KGLCoordinates() ;
		}
		if( in_isUseVBO ) {
			isUseVBO = KGLExtensionCheck.IsExtensionSupported(gl,"GL_ARB_vertex_buffer_object") ;
		}
		glObj = null ;
		if( texPool == null ) {
			texPool = new KGLTextures(gl) ;
			isMakeTexPool = true ;
		}
	}
	private void updateMinMax() {
		if( glObj == null ) return ;
		minPos = null ;
		maxPos = null ;
		for( int o = 0 ; o < glObj.length ; o++ ) {
			if( glObj[o].isVisible ) {
				if( minPos == null ) minPos = KGLPoint.create(glObj[o].minPos) ;
				else minPos.updateMinimam(glObj[o].minPos) ;
				if( maxPos == null ) maxPos = KGLPoint.create(glObj[o].maxPos) ;
				else maxPos.updateMinimam(glObj[o].maxPos) ;
			}
		}
	}
	/**
	 * `LύX<br>
	 * @param objectName	IuWFNg
	 * @param isVisible	`L
	 */
	public void objectVisible(String objectName,boolean isVisible) {
		if( glObj == null ) return ;
		for( int o = 0 ; o < glObj.length ; o++ ) {
			if( objectName.equals(glObj[o].name) ) {
				glObj[o].isVisible = isVisible ;
				break ;
			}
		}
		updateMinMax() ;
	}
	/**
	 * `LύX<br>
	 * @param materialtName	}eA
	 * @param isVisible	`L
	 */
	public void materialVisible(String materialtName,boolean isVisible) {
		if( glObj == null ) return ;
		for( int o = 0 ; o < glObj.length ; o++ ) {
			for( int m = 0 ; m < glObj[o].mat.length ; m++ ) {
				if( materialtName.equals(glObj[o].mat[m].name) ) {
					glObj[o].mat[m].isVisible = isVisible ;
					break ;
				}
			}
		}
		updateMinMax() ;
	}
	/**
	 * `LύX<br>
	 * @param objectName	IuWFNg
	 * @param materialtName	}eA
	 * @param isVisible	`L
	 */
	public void materialVisible(String objectName,String materialtName,boolean isVisible) {
		if( glObj == null ) return ;
		for( int o = 0 ; o < glObj.length ; o++ ) {
			if( ! objectName.equals(glObj[o].name) ) continue ;
			for( int m = 0 ; m < glObj[o].mat.length ; m++ ) {
				if( materialtName.equals(glObj[o].mat[m].name) ) {
					glObj[o].mat[m].isVisible = isVisible ;
					break ;
				}
			}
		}
		updateMinMax() ;
	}
	private boolean[] setEnables = null ;
	private int[] setEnablesInteger = null ;
	private boolean isChangeScale = false ;
	private boolean isNormalize = false ;
	/**
	 * `ɕKvglEnableꊇčsB<br>
	 * glEnablê<br>
	 * GL_DEPTH_TEST<br>
	 * GL_ALPHA_TEST<br>
	 * GL_NORMALIZEiscale1.0ȊȌꍇ̂݁j<br>
	 * 炪KvȂƂ킩ĂƂ͎蓮Őݒ肷ق悢Ǝv܂<br>
	 *@param scale `悷TCYiP{ȊO͂nfkɗ]vȏj
	 */
	public void enables(float scale) {
		setEnables = new boolean[2] ;
		setEnablesInteger = new int[2] ;
		setEnablesInteger[0] = GL.GL_DEPTH_TEST ;
		setEnablesInteger[1] = GL.GL_ALPHA_TEST ;
		for( int i = 0 ; i < setEnables.length ; i++ ) {
			setEnables[i] = gl.glIsEnabled(setEnablesInteger[i]) ;//݂̏Ԃ擾
			if( ! setEnables[i] ) gl.glEnable(setEnablesInteger[i]) ;//݁AȂLɂ
		}

		if( scale != 1.0 ) {
			isChangeScale = true ;
			isNormalize = gl.glIsEnabled(GL.GL_NORMALIZE) ;
			gl.glPushMatrix() ;//XP[̕ύX̓}gbNX̕ۑŌɖ߂
			gl.glScalef(scale,scale,scale) ;
			if( ! isNormalize ) gl.glEnable(GL.GL_NORMALIZE) ;//XP[ςƂOpenGLɖ@̌vZĂȂƂȂ
		}

	}
	/**
	 * `ŎgtOienables()Őݒ肵́jƂ<br>
	 * glDsablê<br>
	 * GL_DEPTH_TEST<br>
	 * GL_ALPHA_TEST<br>
	 * GL_NORMALIZE<br>
	 */
	public void disables() {
		if( setEnables != null && setEnablesInteger != null ) {
			for( int i = 0 ; i < setEnables.length ; i++ ) {
				if( ! setEnables[i] ) gl.glDisable(setEnablesInteger[i]) ;
			}
		}
		if( isChangeScale ) {
			gl.glPopMatrix() ;
			if( ! isNormalize ) gl.glDisable(GL.GL_NORMALIZE) ;
		}
	}
	/**
	 * `<br>
	 * ɎĂf[^`悷
	 */
	public void draw() {
		draw(1.0f) ;
	}
	/**
	 * `<br>
	 * ɎĂf[^`悷
	 *
	 *@param alpha	`悷铧xiO`Pj
	 */
	public void draw(float alpha) {
		float[] fw = new float[4] ;
		if( glObj == null ) return ;
//		gl.glPushMatrix() ;
		/* glEnable^glDisable͌Ăяo̓sɂĕKvȂiȂj
		 * ̂ŁAO(enables(float),disables())ɂB
		gl.glEnable(GL.GL_DEPTH_TEST) ;
		gl.glEnable(GL.GL_ALPHA_TEST) ;
		if( scale != 1.0 ) {
			gl.glScalef(scale,scale,scale) ;
			gl.glEnable(GL.GL_NORMALIZE) ;
		}
		*/
		boolean isGL_TEXTURE_2D = gl.glIsEnabled(GL.GL_TEXTURE_2D) ;
		boolean isGL_BLEND = gl.glIsEnabled(GL.GL_BLEND) ;
		int[] intBlendFunc = new int[2] ;
		gl.glGetIntegerv(GL.GL_BLEND_SRC,intBlendFunc,0) ;
		gl.glGetIntegerv(GL.GL_BLEND_DST,intBlendFunc,1) ;
		if( !isGL_BLEND )gl.glEnable(GL.GL_BLEND) ;
//		gl.glEnable(GL.GL_POLYGON_SMOOTH) ;
		gl.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_ONE_MINUS_SRC_ALPHA) ;

		int[] intFrontFace = new int[1] ;
		gl.glGetIntegerv(GL.GL_FRONT_FACE,intFrontFace,0) ;
		gl.glFrontFace(frontFace) ;//ʂ̕\ݒ肷
		for( int o = 0 ; o < glObj.length ; o++ ) {
			GLObject glo = glObj[o] ;
			if( glo == null ) continue ;
			if( ! glo.isVisible) continue ;
			for( int m = 0 ; m < glo.mat.length ; m++ ) {
				GLMaterial mat = glo.mat[m] ;
				if( mat == null ) continue ;
				if( ! mat.isVisible ) continue ;
				//OpenGL̕`tOݒ
				if( mat.texID != 0 ) {
					gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_CLAMP);
					gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_CLAMP);
					if(!isGL_TEXTURE_2D)gl.glEnable(GL.GL_TEXTURE_2D) ;
				}
				
				if( mat.shadeMode_IsSmooth ) {
					gl.glShadeModel(GL.GL_SMOOTH) ;
				}
				else {
					gl.glShadeModel(GL.GL_FLAT) ;
				}

				//F֌W̐ݒ
				gl.glColor4f(mat.color[0],mat.color[1],mat.color[2],mat.color[3]) ;
				if( mat.dif != null ) {//gUːF̂̐F
//						gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_DIFFUSE,mat.dif,0) ;
					System.arraycopy(mat.dif,0,fw,0,mat.dif.length) ;
					fw[3]*=alpha ;
					gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_DIFFUSE,fw,0) ;
				}
				if( mat.amb != null ) gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_AMBIENT,mat.amb,0) ;//
				if( mat.spc != null ) {//ʔː : ߂̐F
//						gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_SPECULAR,mat.spc,0) ;
					System.arraycopy(mat.spc,0,fw,0,mat.spc.length) ;
					fw[3]*=alpha ;
					gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_SPECULAR,fw,0) ;
				}
				if( mat.emi != null ) gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_EMISSION,mat.emi,0) ;//ˋPx
				if( mat.power != null ) gl.glMaterialf(GL.GL_FRONT_AND_BACK,GL.GL_SHININESS,mat.power[0]) ;//ʌW

				//eNX`̐ݒ
				if( mat.texID != 0 ) {
					gl.glBindTexture(GL.GL_TEXTURE_2D,mat.texID) ;
				}
				//`f[^ݒ
				if( isUseVBO ) {
					gl.glBindBufferARB(GL.GL_ARRAY_BUFFER_ARB,glo.VBO_ids[m]) ;
					gl.glInterleavedArrays(mat.interleaveFormat,0,0) ;
				}
				else {
					mat.interleaved.position(0) ;
					gl.glInterleavedArrays(mat.interleaveFormat,0,mat.interleaved) ;
				}

				//`s
				gl.glDrawArrays(GL.GL_TRIANGLES,0,mat.vertex_num) ;

				//ݒNA
				if( mat.texID != 0 ) {
					gl.glBindTexture(GL.GL_TEXTURE_2D,0) ;
				}
//					gl.glDisable(GL.GL_BLEND) ;
				if( isUseVBO ) {
					gl.glBindBufferARB(GL.GL_ARRAY_BUFFER_ARB,0) ;
				}
				if( mat.texID != 0 ) {
					if(!isGL_TEXTURE_2D)gl.glDisable(GL.GL_TEXTURE_2D) ;
				}
			}
		}
		if( !isGL_BLEND )gl.glDisable(GL.GL_BLEND) ;
		gl.glBlendFunc(intBlendFunc[0],intBlendFunc[1]) ;
		gl.glFrontFace(frontFace) ;//ʂ̕\ݒ肷
			/*
		if( scale != 1.0 ) {
			gl.glDisable(GL.GL_NORMALIZE) ;
		}
		gl.glDisable(GL.GL_ALPHA_TEST) ;
		gl.glDisable(GL.GL_DEPTH_TEST) ;
		*/
//		gl.glPopMatrix() ;
	}
	
	/**
	 * 񁕃oCif[^ǂݍ݃NX
	 * 
	 */
	protected class multiInput {
		/**
		 * ǂݍ݃Xg[
		 */
		private BufferedInputStream bis = null ;
		/**
		 * RXgN^<br>
		 * @param is	̓Xg[
		 */
		public multiInput(InputStream is) {
			bis = new BufferedInputStream(is) ;
		}
		/**
		 * f[^ǂݍ<br>
		 * Xg[b.lengthTCỸf[^ǂݍƂ<br>
		 * ۂɓǂݍ񂾃TCYreturnlQ<br>
		 * @param b	ǂݍ݃obt@
		 * @return	ǂݍ݃TCY
		 * @throws IOException
		 */
		public int read(byte[] b) throws KGLException {
			try {
//				return bis.read(b) ;
				int sz ;
				for( sz = 0 ; sz != (b.length) ; sz += bis.read(b,sz,b.length-sz)) ;
				return sz ;
			}
			catch(IOException ioe) {
				throw new KGLException(ioe) ;
			}
		}
		/**
		 * Xg[N[Y
		 * @throws IOException
		 */
		public void close()throws KGLException {
			try {
				bis.close() ;
			}
			catch(IOException ioe) {
				throw new KGLException(ioe) ;
			}
		}
		/**
		 * Psijǂݍ<br>
		 * 1 s̏I[́As (u\nv) AA (u\rv)A܂͕AƂɑs<br>
		 * ̊֐̂ƁAǂݍ݈ʒu͉s̎ɐi<br>
		 * @return	Ps̃f[^
		 */
		public String readLine() throws KGLException{
			String ret = null ;
			try {
				bis.mark(256) ;//ǂݍݑOɌ݈ʒu}[N
				int idata ;
				int len ;
				int retnum ;
				len = 0 ;
				retnum = 0 ;
				while((idata=bis.read()) != -1) {//ǂݍݕ𐔂
					if( idata == '\n' ) {
						len ++ ;
						break ;
					}
					if( idata == '\r' ) {
						len++ ;
						continue ;
					}
					if( retnum != 0 ) break ;
					len ++ ;
				} ;
				//ǂݍݑOɂ}[N當ǂݍ݁B
				byte[] b = new byte[len] ;
				bis.reset() ;
				read(b) ;
				BufferedReader br = new BufferedReader(new InputStreamReader(
						new ByteArrayInputStream(b))) ;
				ret = br.readLine() ;
			}
			catch(Exception e) {
				throw new KGLException(e) ;
//				e.printStackTrace() ;
			}
			
			return ret ;
		}
	}
	/**
	 * ǂݍ񂾃IuWFNg^}eÂ𕶎ɂ
	 */
	public String toString() {
		String ret = null ;
		String retCode = (String)System.getProperties().get("line.separator") ;
		StringBuffer sb = new StringBuffer() ;
		if( glObj == null ) return "f[^Ȃ" ;
		sb.append("IuWFNg(}eA,...j").append(retCode) ;
		for( int o = 0 ; o < glObj.length ; o++ ) {
			sb.append(glObj[o].name).append("(") ;
			for( int m = 0 ; m < glObj[o].mat.length ; m++ ) {
				sb.append(glObj[o].mat[m].name).append(",");
			}
			sb.append(")").append(retCode) ;
		}
		ret = sb.toString();
		return ret ;
	}
	/**
	 * f̒_̍ŏlo
	 */
	public KGLPoint getMaxPos() {
		return maxPos;
	}
	/**
	 * f̒_̍őlo
	 */
	public KGLPoint getMinPos() {
		return minPos;
	}
}
