package kGLModel;

import javax.media.opengl.GL;
import java.util.*;
import java.nio.*;
import java.net.*;
import java.io.*;           // For File
//import java.awt.image.*;    // For BufferedImage
//import javax.imageio.*;     // For ImageIO
import com.sun.opengl.util.texture.*;
/**
 * eNX`̐ƊǗ<br>
 * xǂݍ񂾃eNX`͍ėpB<br>
 * gpClear()Ăł<br>
 * nfk֓o^\[X̉܂B<br>
 * 
 * @author kei
 *
 */
public class KGLTextures {
	/**
	 * OpenGLR}hQJvZNX
	 * (JOGL)
	 */
	private GL gl ;
	/**
	 * texture name̕ۑRei<br>
	 * eNX`{At@t@C{x<br>
	 * L[OpenGLtexture nameiintjۑĂRei<br>
	 */
	private HashMap<String,Integer> texPool  = null ;
	/**
	 * RXgN^
	 * 
	 */
	public KGLTextures(GL in_gl) {
		gl = in_gl ;
		texPool = new HashMap<String,Integer>() ;
	}
	/**
	 * nfk֓o^\[X
	 *
	 */
	public void Clear() {
		Collection<Integer> collection = texPool.values() ;
		Integer[] ciarray = collection.toArray(new Integer[0]) ;
		if( ciarray.length == 0 ) return ;
		int[] iarray = new int[ciarray.length] ;
		for( int i = 0 ; i < iarray.length ; i++ ) {
			iarray[i] = ciarray[i];
		}
		gl.glDeleteTextures(iarray.length,iarray,0) ;
		texPool.clear() ;
	}
	/**
	 * eNX`̓o^<br>
	 * 
	 * @param isFile	O̓t@CH
	 * @param texname	eNX`t@C
	 * @param alpname	At@t@C
	 * @param reload	true:o^ĂĂt@Cǂݒ
	 * @return			OpenGLtexture nameiintj
	 */
	public int getGLTexture(boolean isFile,String texname,String alpname,boolean reload) {
		if( texname == null && alpname == null ) return 0 ;
		Integer ret = 0 ;
		ret = texPool.get(texname+alpname) ;
		if( !reload ) {//ēǍȂo^ς݂ȂAo^Ă̂Ԃ
			if( ret != null ) return ret ;
		}
		else {//ēǍo^ς݂ȂAo^Ă̂폜
			if( ret != null ) {
				gl.glBindTexture(GL.GL_TEXTURE_2D,0) ;
				glDeleteTexture(ret) ;
				texPool.remove(texname+alpname) ;
				ret = 0 ;
			}
		}
		/*RƏ㉺]Ă摜̑ΉƂxʃt@CŎw肵ĂꍇƂhC
		if( alpname == null ) {
			try {
				Texture gltex = TextureIO.newTexture(new File(texname),false) ;
				boolean bbb = gltex.getMustFlipVertically() ;
				gltex.setTexParameteri(GL.GL_TEXTURE_MAG_FILTER,GL.GL_LINEAR) ;
				gltex.setTexParameteri(GL.GL_TEXTURE_MIN_FILTER,GL.GL_LINEAR) ;
				ret = gltex.getTextureObject() ;
				texPool.put(texname+alpname+alpha,ret) ;
			}
			catch(Exception e) {
				e.printStackTrace() ;
			}
			if( ret != 0 ) return ret ;
		}
		*/
		/* texnameȂA{Iɂ܂ł̏OKȂ͂B@
		 * ȍ~̓At@t@CΉ̂ƂɎg 
		 */
		ByteBuffer images ;
		int size = 0;
		images = loadTexture(isFile,texname,alpname) ;
		if(images == null ) return 0 ;
		size = (int)Math.sqrt((double)images.capacity()/(double)4) ;
		ret = glGenTexture() ;
		if( ret == 0 ) return 0 ;
		gl.glPixelStorei(GL.GL_UNPACK_ALIGNMENT,1) ;
		gl.glPixelStorei(GL.GL_PACK_ALIGNMENT,1) ;
		gl.glBindTexture(GL.GL_TEXTURE_2D,ret) ;
		gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR);
		gl.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR);
		images.position(0) ;
		gl.glTexImage2D(GL.GL_TEXTURE_2D, 0, GL.GL_RGBA8, size, size,
						0, GL.GL_RGBA, GL.GL_UNSIGNED_BYTE, images);
		gl.glBindTexture(GL.GL_TEXTURE_2D,0) ;
		texPool.put(texname+alpname,ret) ;
		return ret ;
	}
	
	/**
	 * OpenGLɃeNX`o^iPj
	 * 
	 * @return	o^texture name(int)
	 */
	private int glGenTexture() {
		int texs[] = new int[1];
		gl.glGenTextures(1,texs,0) ;
		return texs[0] ;
	}
	/**
	 * o^ꂽeNX`폜iPj
	 * 
	 * @param tex	o^ςtexture name(int)
	 */
	private void glDeleteTexture(int tex) {
		int texs[] = new int[1];
		texs[0] = tex ;
		gl.glDeleteTextures(1,texs,0) ;
		return  ;
	}
	/**
	 * C[Wt@Cf[^ǂݍ
	 * 
	 * @param isFile	O̓t@CH
	 * @param texname	eNX`t@C
	 * @param alpname	At@t@C
	 * @return	ǂݍ񂾃f[^
	 */
	protected ByteBuffer loadTexture(boolean isFile,String texname,String alpname) {
		ByteBuffer ret = null  ;
		try {
			KGLtga tga = null ;
			boolean b_alp_MustFlipVertically = false;
			byte balpha ;
			balpha = (byte)(255) ;
			int h,w ;
			int npixel  = 0;
			int napixel = 0;
			int texform = 0 ;
			Buffer bw = null ;
			ByteBuffer bbtex = null ;
			ByteBuffer bbalp = null ;
			byte[] barray = null ;
			byte[] baarray = null ;
			TextureData gltexdata = null ;
			if( isFile ) {
				gltexdata = TextureIO.newTextureData(new File(texname),false,null) ;
			}
			else {
				gltexdata = TextureIO.newTextureData(new URL(texname),false,null) ;
			}
			texform = gltexdata.getPixelFormat() ;
			bw = gltexdata.getBuffer() ;
			if( bw instanceof ByteBuffer ) {
				bbtex = (ByteBuffer)bw ;
				barray = bbtex.array() ;
			}
			h = gltexdata.getHeight();
			w = gltexdata.getWidth() ;
			TextureData glalpdata = null ;
			try {
				if( isFile ) {
					if( alpname != null ) glalpdata = TextureIO.newTextureData(new File(alpname),false,null) ;
				}
				else {
					if( alpname != null ) glalpdata = TextureIO.newTextureData(new URL(alpname),false,null) ;
				}
				if( glalpdata != null ) {
					bw = glalpdata.getBuffer() ;
					if( bw instanceof ByteBuffer ) {
						if( h == glalpdata.getHeight() && w == glalpdata.getWidth() ) {
							bbalp = (ByteBuffer)bw ;
							baarray = bbalp.array() ;
							napixel = baarray.length/(h*w) ;
						}
					}
					b_alp_MustFlipVertically = glalpdata.getMustFlipVertically() ;
				}
			}
			catch(IOException ioe) {
//				ioe.printStackTrace() ;
				//TGAt@C̃mNtH[}bgΉĂȂۂ̂Ŏ͂œǂł݂B
				//java.io.IOException: TGADecoder Uncompressed Grayscale images not supported
				try {
					if( isFile ) {
						tga = new KGLtga(new File(alpname) ) ;
					}
					else {
						tga = new KGLtga(new URL(alpname) ) ;
					}
					if( h == tga.header.height && w == tga.header.width ) {
						baarray = tga.data ;
						napixel = tga.header.depth/8 ;
						b_alp_MustFlipVertically = ! tga.hight_UndaerToTop ;
					}
				}
				catch(Exception e) {
					throw new KGLException("eNX`ǂݍ݃G[") ;
//					e.printStackTrace() ;
				}
			}
			npixel = barray.length ;
			npixel /= (h*w);
			ret = ByteBuffer.allocateDirect(h*w*4) ;
			ret.order(ByteOrder.nativeOrder()) ;
			int hini = 0;
			int hmin = 0 ;
			int hmax = h;
			int hadd = 1;
			if( !gltexdata.getMustFlipVertically() ) {
				hini = h-1 ;
				hadd = -1 ;
			}
			for( int hp = hini ; hmin <= hp && hp < hmax ; hp+=hadd ) {
				for( int wp = 0 ; wp < w ; wp++ ) {
					if( texform == GL.GL_BGR || texform == GL.GL_BGRA ) {
						ret.put(barray[(hp*w+wp)*npixel+2]) ;
						ret.put(barray[(hp*w+wp)*npixel+1]) ;
						ret.put(barray[(hp*w+wp)*npixel+0]) ;
					}
					else {
						ret.put(barray[(hp*w+wp)*npixel+0]) ;
						ret.put(barray[(hp*w+wp)*npixel+1]) ;
						ret.put(barray[(hp*w+wp)*npixel+2]) ;
					}
					if( baarray != null ) {
						if( (hini != 0 && (b_alp_MustFlipVertically)) || 
								(hini == 0 && (!b_alp_MustFlipVertically) )
								) { //eNX`t@CƃAt@t@CŊi[t̏ꍇ
							ret.put(baarray[((hmax-1-hp)*w+wp)*napixel+napixel-1]) ;
						}
						else {
							ret.put(baarray[(hp*w+wp)*napixel+napixel-1]) ;
						}
						continue ;
					}
					if( texform == GL.GL_BGRA || texform == GL.GL_RGBA) {
						ret.put(barray[(hp*w+wp)*npixel+3]) ;
						continue ;
					}
					ret.put(balpha) ;
				}
			}
			
			/* com.sun.opengl.util.texturegȂŉ摜ǂݍ݂Ƃ̃\[X
		BufferedImage tex = null ;
		BufferedImage alp = null ;
			File texf ;
			texf = new File(texname) ;
			tex = ImageIO.read(texf) ;
			if( alpname != null ) alp = ImageIO.read(new File(alpname)) ;
			Raster rtr ;
			Raster artr = null  ;
			int ty ;
			Object data ;
			Object adata ;
			h = tex.getHeight();
			w = tex.getWidth() ;
			rtr = tex.getData() ;
			data = rtr.getDataElements(0,0,h,w,null) ;
			byte[] bdata = (byte[])data ;
			byte[] balp = null ;
			int anpixel = 0 ;
			int aoffset = 0 ;
			if( alpname != null ) {
				if( h == alp.getHeight() && w == alp.getWidth() ) {
					artr = alp.getData() ;
					adata = artr.getDataElements(0,0,h,w,null) ;
					if( adata instanceof byte[] ) {
						balp = (byte[]) adata ;
						anpixel = artr.getNumDataElements() ;
						aoffset = (anpixel-1) ;
					}
				}
			}
			ty = rtr.getTransferType() ;
			if( ty != DataBuffer.TYPE_BYTE ) throw new Exception("f[^z񂪂悭킩") ;
			npixel = rtr.getNumDataElements() ;
			if( h != w ) throw new Exception("eNX`̏c") ;
			if( data instanceof byte[] ) {
				ret = ByteBuffer.allocateDirect(h*w*4) ;
				ret.order(ByteOrder.nativeOrder()) ;
				for( int i = 0 ; i < h*w ; i++ ) {
					ret.put(i*4+0,(byte)(bdata[i*npixel+0])) ;
					ret.put(i*4+1,(byte)(bdata[i*npixel+1])) ;
					ret.put(i*4+2,(byte)(bdata[i*npixel+2])) ;
					if( balp == null ) {
						ret.put(i*4+3,(byte)(balpha)) ;
					}
					else {
						ret.put(i*4+3,(byte)(balp[i*anpixel+aoffset])) ;
					}
				}
			}
			ret.position(0) ;
					
		*/
		}
		catch(Exception e) {
			e.printStackTrace() ;
			ret = null ;
		}
		return ret ;
	}

}
