package kGLModel;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLCapabilities;

/**
 * A`GCAXsNX<br>
 * ̗<br>
 * <pre>
 * E
 * Pj`悷ʂ̃AL[Vobt@LɂB
 * 		iGLCanvas܂GLJPanel쐬Ƃȉ̗pɂj
 * 		GLCanvas canvas = new GLCanvas(KGLAntiAlias.accumOn(new GLCapabilities()));
 * QjKGLAntiAlias쐬
 * 		antialias = new KGLAntiAlias(GLNX) ;
 * Eۂ̕`揈iGLEventListenervoid display(GLAutoDrawable)j̒Łj
 * Rj`O
 * 		antialias.start(0.5f)
 * 		̐ςƃA`GCAX̂ς̂ŁADȐĂ
 * Sj`惋[v쐬i[v̒ɕ`揈j
 * 		for( int c = 0 ; c < antialias.getJitterCount() ; c++ ) {
 * 			antialias.jitter(c) ;@_Ԃ炵
 * 			`揈
 * 			antialias.add() ;@AL[Vobt@ɒǉ
 * 		}
 * TjAL[Vobt@̓eJ[obt@ɂǂ
 * 		GL.glClear(GL.GL_COLOR_BUFFER_BIT); 
 * 		antialias.flush() ;
 * </pre>
 * <br>
 * ӁIIPROJECTIONsĂ킯łA_Iȗt킯ł͂܂B<br>
 * Č΁AglFrustumprojectionsƂ̔z<br>
 * z<br>
 * b@`@O@b@O@b<br>
 * b@O@a@c@O@b<br>
 * b@O@O@d@e@b<br>
 * b@O@O@-1@O@b<br>
 * `Q^iright-leftj<br>
 * aQ^itop-bottomj<br>
 * b|iright+leftj^iright-leftj<br>
 * c|itop+bottomj^itop-bottomj<br>
 * d|ifar+nearj^ifar-nearj<br>
 * e|i2farnearj^ifar-nearj<br>
 * 炵BBBƂƂłB<br>
 * @author kei
 *
 */
public class KGLAntiAlias {
	/**
	 * OpenGLR}hQJvZNX
	 * (JOGL)
	 */
	private GL gl ;
	
	private int jitterCount ;
	private float jitterTable[];
	private float projection[] ;
	private float orgProjection[] ;
	private int view[] ;
	private float magnificationX ;
	private float magnificationY ;

	
	/**
	 * AL[Vobt@̃rbgZbgB<br>
	 * ̃\bh̖߂lGLCanvasGLJPanel̃RXgN^̈Ƃ<br>
	 * @param caps	ǉGLCapabilities
	 * @return	accumobt@̐ݒGLCapabilities
	 */
	static public GLCapabilities accumOn(GLCapabilities caps) {
	    caps.setAccumAlphaBits(caps.getAlphaBits()) ;
	    caps.setAccumBlueBits(caps.getBlueBits()) ;
	    caps.setAccumGreenBits(caps.getGreenBits()) ;
	    caps.setAccumRedBits(caps.getRedBits()) ;
	    return caps ;
	}
	/**
	 * RXgN^
	 * @param in_gl	OpenGLR}hQJvZNX
	 */
	public KGLAntiAlias(GL in_gl) {
		gl = in_gl ;
		jitterCount = 4 ;
		jitterTable = new float[4*2] ;
		jitterTable[0] = -0.2082f ;	jitterTable[1] =  0.3537f ;
		jitterTable[2] =  0.2039f ;	jitterTable[3] = -0.3538f ;
		jitterTable[4] = -0.2926f ;	jitterTable[5] =  0.1499f ;
		jitterTable[6] =  0.2969f ;	jitterTable[7] = -0.1500f ;
		orgProjection = new float[16] ;
		projection = new float[16] ;
		view = new int[4] ;
		//ALobt@̏lݒ
		gl.glClearAccum(0.0f, 0.0f, 0.0f, 0.0f);
	}
	/**
	 * A`GCAX̊Jn
	 * @param baseMagnification	_Ԃ炷̒{
	 */
	public void start(float baseMagnification) {
		gl.glClear(GL.GL_ACCUM_BUFFER_BIT) ;
		gl.glGetFloatv(GL.GL_PROJECTION_MATRIX,orgProjection,0) ;
		gl.glGetFloatv(GL.GL_PROJECTION_MATRIX,projection,0) ;
	    gl.glGetIntegerv(GL.GL_VIEWPORT,view,0) ;
	    magnificationX = 10f/(view[2]) ;
	    magnificationY = 10f/(view[3]) ;
	    magnificationX *= baseMagnification ;
	    magnificationY *= baseMagnification ;
	}
	/**
	 * AL[Vobt@֒ǉ<br>
	 * {͂P^Ԃ炷
	 */
	public void add() {
		gl.glAccum(GL.GL_ACCUM,1.0f/jitterCount) ;
	}
	/**
	 * J[obt@֏<br>
	 * AL[Vobt@̓eJ[obt@֖߂
	 *
	 */
	public void flush() {
		gl.glAccum(GL.GL_RETURN,1.0f) ;
		gl.glMatrixMode(GL.GL_PROJECTION) ;
		gl.glLoadMatrixf(orgProjection,0) ;
	}
	/**
	 * Ԃ炷񐔂oB<br>
	 * ̉񐔕A`肩ȂƂȂB
	 * @return	Ԃ炷
	 */
	public int getJitterCount() {
		return jitterCount;
	}
	/**
	 * _Ԃ炵s<br>
	 * 
	 * @param count	`񐔁iڂj
	 */
	public void jitter(int count) {
		if( count < 0 ) return ;
		if( jitterCount <= count ) return ;
		int mode[] = new int[1] ;
		gl.glGetIntegerv(GL.GL_MATRIX_MODE,mode,0) ;
		if( count < 2 ) {
			projection[0] = orgProjection[0] - (jitterTable[count*2+0]*magnificationX*0.5f) ;
			projection[8] = orgProjection[8] + (jitterTable[count*2+0]*magnificationX*0.5f) ;
		}
		else {
			projection[0] = orgProjection[0] - (jitterTable[count*2+0]*magnificationX) ;
			projection[8] = orgProjection[8] + (jitterTable[count*2+0]*magnificationX) ;
			projection[5] = orgProjection[5] + (jitterTable[count*2+1]*magnificationY) ;
			projection[9] = orgProjection[9] - (jitterTable[count*2+1]*magnificationY) ;
		}
		gl.glMatrixMode(GL.GL_PROJECTION) ;
		
//		gl.glLoadIdentity() ;
//		gl.glMultMatrixf(projection,0) ;
		gl.glLoadMatrixf(projection,0) ;
		gl.glMatrixMode(mode[0]) ;
	}
}
