package kGLModel;

import javax.media.opengl.GL;
import javax.media.opengl.glu.GLU;

import java.nio.Buffer;
import java.nio.ByteBuffer;
import java.nio.IntBuffer;
import java.util.* ;

/**
 * eNX<br>
 * gp@<br>
 * E<br>
 * @init()<br>
 * @ݒ肷shadowMap̃TCYŉe̐x܂B<br>
 * @A傫ƃmۂɎŝŃzhzh<br>
 * @iFBOT|[gĂȂꍇviewportˑɂȂ܂j<br>
 * <br>
 * E`掞̎菇<br>
 * @1)beforeMakeShadowMap()<br>
 * @2)etΏۂ`<br>
 * @3)afterMakeShadowMap()<br>
 *   @ŃNXshadowMap쐬<br>
 * @4)beforeDrowSiene() `Ώۂ̕`{e̕`@sׂ̏<br>
 * @5)etΏۂ`@2)Ɠ<br>
 * @6)afterDrowSiene()<br>
 * <br>
 * shadow map쐬iL1),2)jʂNÂŃobNOh̕`擙
 * shadow Map쐬ȍ~iL3)4)̊ԁjɍsKvB
 * <br>
 * <br>
 * `̈GL_MODELVIEW_MATRIXg^k܂łƂ܂ȂƎvBBB<br>
 * @author kei
 *
 */
public class KGLShadowMapping {
	/**
	 * OpenGLR}hQJvZNX
	 * (JOGL)
	 */
	private GL gl;
	/**
	 * OpenGLR}hQJvZNX
	 * (JOGL)
	 */
	private GLU glu ;

	/**
	 * t[obt@IuWFNg
	 */
	protected KGLfbo fbo = null ;
	/**
	 * t[obt@IuWFNgT|[gĂȂꍇɎgpeNX`
	 */
	int[] tex_shadowmap = null ;
	/**
	 * [xobt@݂̂shadow mapɏoǂ̃tO<br>
	 * false ɂăJ[obt@gp̂́A܂łfobOpr<br>
	 */
	private boolean isDepthOnly = true ;
	/**
	 * NX<br>
	 */
	public KGLLight light = null ;
	/**
	 * OpenGLŎgpVF[_vO̔ԍ<br>
	 */
	private  int shader_pro = -1 ;
	
	/**
	 * ʏ`ŎgpeNX`jbg̔ԍiO`RPj<br>
	 */
	private int[] textureUnit_number = null ;
	/**
	 * shadow mapƂĎgpeNX`jbg̔ԍiO`RPj<br>
	 */
	private int	textureUnit_numberForShadowMap = -1 ;
	/**
	 * VhE}bv̕
	 */
	private int shadowmap_width = 0 ;
	/**
	 * VhE}bv̍
	 */
	private int shadowmap_height = 0 ;
	
//	private float[] clear_color = new float[4] ;
	/**
	 * VIEWPORTۑobt@<br>
	 * shadow map쐬Aɖ߂߂Ɏgp<br>
	 */
	private int[] viewport = new int[4] ;
	/**
	 * MODELVIEWۑobt@<br>
	 * shadow map쐬Aɖ߂߂Ɏgp<br>
	 */
	private double[] modelview = new double[16] ;
	/**
	 * PROJECTIONۑobt@<br>
	 * shadow map쐬Aɖ߂߂Ɏgp<br>
	 */
	private double[] projection = new double[16] ;
	/**
	 * ݂MODELVIEWۑobt@<br>
	 */
	private double[] light_modelview = new double[16] ;


	/**
	 * eNX`jbgԍOpenGLŎgpeNX`jbg̒l̑Ήz
	 */
	private final static int[] textureUnit = {
		GL.GL_TEXTURE0,GL.GL_TEXTURE1,GL.GL_TEXTURE2,GL.GL_TEXTURE3,GL.GL_TEXTURE4,
		GL.GL_TEXTURE5,GL.GL_TEXTURE6,GL.GL_TEXTURE7,GL.GL_TEXTURE8,GL.GL_TEXTURE9,
		GL.GL_TEXTURE10,GL.GL_TEXTURE11,GL.GL_TEXTURE12,GL.GL_TEXTURE31,GL.GL_TEXTURE14,
		GL.GL_TEXTURE15,GL.GL_TEXTURE16,GL.GL_TEXTURE17,GL.GL_TEXTURE18,GL.GL_TEXTURE19,
		GL.GL_TEXTURE20,GL.GL_TEXTURE21,GL.GL_TEXTURE22,GL.GL_TEXTURE23,GL.GL_TEXTURE24,
		GL.GL_TEXTURE25,GL.GL_TEXTURE26,GL.GL_TEXTURE27,GL.GL_TEXTURE28,GL.GL_TEXTURE29,
		GL.GL_TEXTURE30,GL.GL_TEXTURE31
	} ;
	
	/**
	 * ŕێĂshadow map摜ԍƂ肾
	 * @param isRGBA	true:J[摜 false:[x摜
	 * @return	OpenGLɓo^ĂeNX`ԍ
	 */
	public int getShadowMapImage(boolean isRGBA) {
		if( fbo == null ) {
			if( isDepthOnly ) return 0 ;
			else return tex_shadowmap[0] ;
		}
		if( isRGBA ) return fbo.getTextureRGBA() ;
		return fbo.getTextureDepth() ;
	}
	/**
	 * RXgN^<br>
	 * g@\̗L̃`FbNĂ
	 * @param in_gl	OpenGLR}hQJvZNX
	 * @param in_glu	OpenGLR}hQJvZNX
	 * @throws KGLException	gpg@\hCoŃT|[gĂȂ
	 */
	public KGLShadowMapping(GL in_gl, GLU in_glu) throws KGLException {
		gl = in_gl ;
		glu = in_glu ;
		if ( !KGLExtensionCheck.IsExtensionSupported(in_gl,"GL_ARB_fragment_shader") || 
				!KGLExtensionCheck.IsExtensionSupported(in_gl,"GL_ARB_vertex_shader") || 
				!KGLExtensionCheck.IsExtensionSupported(in_gl,"GL_ARB_shader_objects") || 
				!KGLExtensionCheck.IsExtensionSupported(in_gl,"GL_ARB_shading_language_100") 
			) {
			throw new KGLException("OpenGL Shading Language is not supported") ;
		}
		try {
			fbo = new KGLfbo(in_gl) ;
		}
		catch(KGLException kgle) {
			fbo = null ;
//			throw kgle ;
		}
//		fbo = null ;
	}
	/**
	 * gpĂOpenGLIuWFNg폜
	 *
	 */
	public void clear() {
		gl.glDeleteObjectARB(shader_pro) ;
		shader_pro = -1 ;
		fbo = null ;
		light = null ;
	}
	
	/**
	 * gp<br>
	 * shadow map̃TCYŉe̐x܂<br>
	 * t[obt@IuWFNgT|[gĂȂꍇviewportˑɂȂ̂ŁA
	 * shadowMapWidthAshadowMapHeight͎gpȂ<br>
	 * @param in_light						IuWFNg
	 * @param in_textureUnit				`ŎgpeNX`jbgԍiO`RPj
	 * @param in_textureUnitForShadowMap	shadow mapƂĎgpeNX`jbgԍiO`RPj
	 * @param shadowMapWidth				shadow map̃TCYij
	 * @param shadowMapHeight				shadow map̃TCYij
	 * @param minimam_shadow				e̍Œᓧx
	 * @throws KGLException	VF[_vÕRpC^Ns<br>
	 * 							KGLException::getInfo()ŏڍ׏񂪎oB
	 */
	public void init(KGLLight in_light,int[] in_textureUnit,int in_textureUnitForShadowMap,
			int shadowMapWidth,int shadowMapHeight,float minimam_shadow) throws KGLException {
		init(in_light,in_textureUnit,in_textureUnitForShadowMap,shadowMapWidth,shadowMapHeight,minimam_shadow,false) ;
	}
	/**
	 * gp<br>
	 * shadow map̃TCYŉe̐x܂<br>
	 * t[obt@IuWFNgT|[gĂȂꍇviewportˑɂȂ̂ŁA
	 * shadowMapWidthAshadowMapHeight͎gpȂ<br>
	 * @param in_light						IuWFNg
	 * @param in_textureUnit				`ŎgpeNX`jbgԍiO`RPj
	 * @param in_textureUnitForShadowMap	shadow mapƂĎgpeNX`jbgԍiO`RPj
	 * @param shadowMapWidth				shadow map̃TCYij
	 * @param shadowMapHeight				shadow map̃TCYij
	 * @param minimam_shadow				e̍Œᓧx
	 * @throws KGLException	VF[_vÕRpC^Ns<br>
	 * 							KGLException::getInfo()ŏڍ׏񂪎oB
	 */
	public void init(KGLLight in_light,int in_textureUnit,int in_textureUnitForShadowMap,
			int shadowMapWidth,int shadowMapHeight,float minimam_shadow) throws KGLException {
		init(in_light,in_textureUnit,in_textureUnitForShadowMap,shadowMapWidth,shadowMapHeight,minimam_shadow,false) ;
	}
	/**
	 * gp<br>
	 * shadow map̃TCYŉe̐x܂<br>
	 * t[obt@IuWFNgT|[gĂȂꍇviewportˑɂȂ̂ŁA
	 * shadowMapWidthAshadowMapHeight͎gpȂ<br>
	 * J[obt@ɏoݒłBA܂łfobOp
	 * @param in_light						IuWFNg
	 * @param in_textureUnit				`ŎgpeNX`jbgԍiO`RPj
	 * @param in_textureUnitForShadowMap	shadow mapƂĎgpeNX`jbgԍiO`RPj
	 * @param shadowMapWidth				shadow map̃TCYij
	 * @param shadowMapHeight				shadow map̃TCYij
	 * @param minimam_shadow				e̍Œᓧx
	 * @param isDrowColorMap				J[obt@ɂoǂ̃tO<br>
	 * 										J[obt@͂܂łfobOp
	 * @throws KGLException	VF[_vÕRpC^Ns<br>
	 * 							KGLException::getInfo()ŏڍ׏񂪎oB
	 */
	public void init(KGLLight in_light,int in_textureUnit,int in_textureUnitForShadowMap,
			int shadowMapWidth,int shadowMapHeight,float minimam_shadow,boolean isDrowColorMap) throws KGLException {
		int[] textures = new int[1] ;
		textures[0] = in_textureUnit ;
		init(in_light,textures,in_textureUnitForShadowMap,shadowMapWidth,shadowMapHeight,minimam_shadow,isDrowColorMap) ;
	}
	/**
	 * gp<br>
	 * shadow map̃TCYŉe̐x܂<br>
	 * t[obt@IuWFNgT|[gĂȂꍇviewportˑɂȂ̂ŁA
	 * shadowMapWidthAshadowMapHeight͎gpȂ<br>
	 * J[obt@ɏoݒłBA܂łfobOp
	 * @param in_light						IuWFNg
	 * @param in_textureUnit				`ŎgpeNX`jbgԍiO`RPj
	 * @param in_textureUnitForShadowMap	shadow mapƂĎgpeNX`jbgԍiO`RPj
	 * @param shadowMapWidth				shadow map̃TCYij
	 * @param shadowMapHeight				shadow map̃TCYij
	 * @param minimam_shadow				e̍Œᓧx
	 * @param isDrowColorMap				J[obt@ɂoǂ̃tO<br>
	 * 										J[obt@͂܂łfobOp
	 * @throws KGLException	VF[_vÕRpC^Ns<br>
	 * 							KGLException::getInfo()ŏڍ׏񂪎oB
	 */
	public void init(KGLLight in_light,int[] in_textureUnit,int in_textureUnitForShadowMap,
			int shadowMapWidth,int shadowMapHeight,float minimam_shadow,boolean isDrowColorMap) throws KGLException {
		//oɃRs[
		isDepthOnly = ! isDrowColorMap ;
		light = in_light ;
		textureUnit_number = new int[in_textureUnit.length] ;
		System.arraycopy(in_textureUnit,0,textureUnit_number,0,in_textureUnit.length) ;
		textureUnit_numberForShadowMap = in_textureUnitForShadowMap;
		shadowmap_width = shadowMapWidth ;
		shadowmap_height = shadowMapHeight ;
		try {
			makeShaderProgram(minimam_shadow) ;
			if( fbo != null ) {
				fbo.setup(shadowMapWidth,shadowMapHeight, isDepthOnly) ;
			}
			else {
				init_tex_shadowmap() ;
			}
		}
		catch(KGLException e ) {
			clear() ;
			throw e ;
		}
	}
	/**
	 * t[obt@IuWFNgT|[gĂȂꍇɎgp
	 * VhE}bvpeNX`̐ݒB<br>
	 * TCYviewport̃TCYɂȂB<br>
	 * viewport̃TCYς鎞ɂ́ÃoĂ񂾕B<br>
	 * 
	 *
	 */
	public void init_tex_shadowmap() {
		if( fbo != null ) return ;//FBOT|[gĂꍇAȂɂȂ
		if( tex_shadowmap == null ) tex_shadowmap = new int[1] ;
		else gl.glDeleteTextures(1,tex_shadowmap,0) ;
		int[] w_view = new int[4] ;
	    gl.glGetIntegerv(GL.GL_VIEWPORT,w_view,0) ;
		shadowmap_width = w_view[2] ;
		shadowmap_height = w_view[3] ;
		gl.glActiveTexture(textureUnit[textureUnit_numberForShadowMap]) ;
		gl.glEnable(GL.GL_TEXTURE_2D);
		gl.glGenTextures( 1, tex_shadowmap,0 );
		gl.glBindTexture( GL.GL_TEXTURE_2D, tex_shadowmap[0] );
		gl.glPixelStorei(GL.GL_UNPACK_ALIGNMENT,1);
		gl.glPixelStorei(GL.GL_PACK_ALIGNMENT,1);
		if( isDepthOnly ) {
			gl.glTexImage2D( GL.GL_TEXTURE_2D, 0, GL.GL_DEPTH_COMPONENT,
					shadowmap_width, shadowmap_height, 0,
					GL.GL_DEPTH_COMPONENT, GL.GL_UNSIGNED_BYTE, (Buffer)null );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
	//		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_CLAMP_TO_EDGE );
	//		gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_CLAMP_TO_EDGE );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_CLAMP );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_CLAMP );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_COMPARE_MODE, GL.GL_COMPARE_R_TO_TEXTURE );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_COMPARE_FUNC, GL.GL_LEQUAL );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_DEPTH_TEXTURE_MODE, GL.GL_LUMINANCE );
		}
		else {
			gl.glTexImage2D( GL.GL_TEXTURE_2D, 0, GL.GL_RGBA, 
					shadowmap_width, shadowmap_height, 0, 
					GL.GL_RGBA, GL.GL_UNSIGNED_BYTE, (Buffer)null );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_CLAMP );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_CLAMP );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_COMPARE_MODE, GL.GL_COMPARE_R_TO_TEXTURE );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_COMPARE_FUNC, GL.GL_LEQUAL );
			gl.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_DEPTH_TEXTURE_MODE, GL.GL_LUMINANCE );
		}
		/*  */
		/* 
		// eNX`WɎ_Wnɂ镨̂̍Wlp
		gl.glTexGeni(GL.GL_S, GL.GL_TEXTURE_GEN_MODE, GL.GL_EYE_LINEAR);
		gl.glTexGeni(GL.GL_T, GL.GL_TEXTURE_GEN_MODE, GL.GL_EYE_LINEAR);
		gl.glTexGeni(GL.GL_R, GL.GL_TEXTURE_GEN_MODE, GL.GL_EYE_LINEAR);
		gl.glTexGeni(GL.GL_Q, GL.GL_TEXTURE_GEN_MODE, GL.GL_EYE_LINEAR);

		// eNX`Ŵ܂ (S, T, R, Q) Ɏg
		double[][] genfunc = {
		{ 1.0, 0.0, 0.0, 0.0 },
		{ 0.0, 1.0, 0.0, 0.0 },
		{ 0.0, 0.0, 1.0, 0.0 },
		{ 0.0, 0.0, 0.0, 1.0 },
		};
		gl.glTexGendv(GL.GL_S, GL.GL_EYE_PLANE, genfunc[0],0);
		gl.glTexGendv(GL.GL_T, GL.GL_EYE_PLANE, genfunc[1],0);
		gl.glTexGendv(GL.GL_R, GL.GL_EYE_PLANE, genfunc[2],0);
		gl.glTexGendv(GL.GL_Q, GL.GL_EYE_PLANE, genfunc[3],0);
		/* */

		gl.glBindTexture(GL.GL_TEXTURE_2D,0) ;
		gl.glDisable(GL.GL_TEXTURE_2D);
		gl.glActiveTexture(textureUnit[textureUnit_number[0]]) ;
	}
	/**
	 * shadow map쐬<br>
	 * ̃\bhĂ񂾌ɉetf`悷邱Ƃshadow map쐬B<br>
	 * fovynear̓fobOpɃJ[obt@oĒƂł傤BBB<br>
	 * <img src="beforeMakeShadowMap.JPG">
	 * 
	 * @param lookX	猩iXWj
	 * @param lookY	猩iYWj
	 * @param lookZ	猩iZWj
	 * @param fovy		猩鎞̎̐ς̉p<br>
	 * @param near		猩鎞̎̐ς̎Öʒu<br>
	 * @param upX		猩鎞̏̃xNgiXj
	 * @param upY		猩鎞̏̃xNgiYj
	 * @param upZ		猩鎞̏̃xNgiZj
	 */
	public void beforeMakeShadowMap(double lookX,double lookY,double lookZ,
			double fovy,double near,
			double upX,double upY,double upZ) {
		if( shader_pro == -1 ) return ;
		//FBOgpJn
  		if( fbo != null ) fbo.use_start() ;
  		
  		//FBÕJ[obt@A[xobt@NAiʏ`obt@ꏏɃNAĂ܂܂j
		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);	// 
//		gl.glGetFloatv(GL.GL_COLOR_CLEAR_VALUE,clear_color,0) ;
//		gl.glGetFloatv(GL.GL_CURRENT_COLOR,clear_color,0) ;
		//݂̕`ۑĂ
	    gl.glGetIntegerv(GL.GL_VIEWPORT,viewport,0) ;
	    gl.glGetDoublev(GL.GL_PROJECTION_MATRIX,projection,0) ;
	    gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX,modelview,0) ;
	    //VIEWPORTFBÕTCYŐݒ肷
		gl.glViewport(0,0,shadowmap_width,shadowmap_height) ;
		//PROJECTIONPʍsŐݒ肷
	    gl.glMatrixMode(GL.GL_PROJECTION) ;
	    gl.glLoadIdentity() ;
	    //MODELVIEW̐ݒō쐬
	    gl.glMatrixMode(GL.GL_MODELVIEW) ;
	    gl.glLoadIdentity() ;
	    double x = light.pos.X() - lookX ;
	    double y = light.pos.Y() - lookY ;
	    double z = light.pos.Z() - lookZ ;
	    double dist = x*x + y*y + z*z ; 
	    dist = Math.sqrt(dist) ;
	    glu.gluPerspective(fovy, (double)shadowmap_width/shadowmap_height, near, dist*3);
	    glu.gluLookAt(light.pos.X(),light.pos.Y(),light.pos.Z(),lookX,lookY,lookZ,upX,upY,upZ) ;

	    //݂MODLVIEWۑ
	    gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX,light_modelview,0) ;
	  
	    //shadow map`p̃tOݒ
	    gl.glColorMask(!isDepthOnly,!isDepthOnly,!isDepthOnly,!isDepthOnly) ;
	    if( isDepthOnly ) {
	    	light.off() ;
		    gl.glEnable(GL.GL_CULL_FACE);	
		    gl.glCullFace(GL.GL_FRONT) ;//\ʂ\gȂh
	    }
	    else {
	        gl.glClearColor(0.25f, 0.5f, 0.5f, 1.0f);
	    	light.on() ;
		    gl.glDisable(GL.GL_CULL_FACE);	
	    }

	    gl.glEnable(GL.GL_DEPTH_TEST); //[xobt@gp
	    
	    //z-fighting΍B
		gl.glEnable( GL.GL_POLYGON_OFFSET_FILL );
		gl.glPolygonOffset( 1.1f, 4.0f );

	}
	/**
	 * shadow map쐬㏈<br>
	 * `ɂǂB
	 */
	public void afterMakeShadowMap() {
		if( shader_pro == -1 ) return ;
		gl.glDisable( GL.GL_POLYGON_OFFSET_FILL );
		if( fbo != null ) {
			fbo.use_end() ;
		}
		else {
			gl.glActiveTexture(textureUnit[textureUnit_numberForShadowMap]) ;
			gl.glBindTexture( GL.GL_TEXTURE_2D, tex_shadowmap[0] );
			gl.glCopyTexSubImage2D(GL.GL_TEXTURE_2D, 0, 0, 0, 0, 0, shadowmap_width, shadowmap_height);
			gl.glBindTexture(GL.GL_TEXTURE_2D,0) ;
			gl.glActiveTexture(textureUnit[textureUnit_number[0]]) ;
		}


	    gl.glViewport(viewport[0],viewport[1],viewport[2],viewport[3]) ;
	    gl.glMatrixMode(GL.GL_PROJECTION) ;
	    gl.glLoadIdentity() ;
	    gl.glLoadMatrixd(projection,0) ;
	    gl.glColorMask(true,true,true,true) ;
	    gl.glDisable(GL.GL_CULL_FACE);	
		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT) ;

		gl.glMatrixMode(GL.GL_MODELVIEW) ;
	    gl.glLoadIdentity() ;
	    gl.glLoadMatrixd(modelview,0) ;
	    
//	    gl.glClearColor(clear_color[0],clear_color[1],clear_color[2],clear_color[3]) ;


	}
	/**
	 * etf`̑O<br>
	 * ̃\bhŃVF[_vO̎gpJnB<br>
	 * ̃\bhĂ񂾌ɉetf`悷ƁAetŕ`悳B<br>
	 */
	public void beforeDrowSiene() {
		if( shader_pro == -1 ) return ;
		//shadow mapŎgpeNX`jbgLɂAshadow mapт
		gl.glActiveTexture( textureUnit[textureUnit_numberForShadowMap] );
		if( fbo != null ) {
			gl.glBindTexture(GL.GL_TEXTURE_2D,fbo.getTextureDepth()) ;
		}
		else {
			gl.glBindTexture(GL.GL_TEXTURE_2D,tex_shadowmap[0]) ;
		}
		//eNX`ϊs̐ݒ
		gl.glMatrixMode(GL.GL_TEXTURE) ;
		gl.glLoadIdentity() ;
		// |P`P͈̔͂O`P͈̔͂ɕϊ
		gl.glTranslated(0.5,0.5,0.5) ;
		gl.glScaled(0.5,0.5,0.5) ;
		//shadow map̍s
		gl.glMultMatrixd(light_modelview,0) ;
		//s̕sړ͌ŕϊ̂Ŏ肾ĂO
		double[] modelview_rotate = new double[modelview.length] ;
		System.arraycopy(modelview,0,modelview_rotate,0,modelview.length) ;
		double[] xyz0 = new double[3] ;
		double[] xyz1 = new double[3] ;
		xyz0[0] = modelview[3] ;
		xyz0[1] = modelview[7] ;
		xyz0[2] = modelview[11] ;
		xyz1[0] = modelview[12] ;
		xyz1[1] = modelview[13] ;
		xyz1[2] = modelview[14] ;
		modelview_rotate[3] = 0 ;
		modelview_rotate[7] = 0 ;
		modelview_rotate[11] = 0 ;
		modelview_rotate[12] = 0 ;
		modelview_rotate[13] = 0 ;
		modelview_rotate[14] = 0 ;
		//tsi]͂łBBBnYj
		gl.glMultTransposeMatrixd(modelview_rotate,0) ;
		//sړ̋tϊȂ
		gl.glTranslated(-1*xyz1[0],-1*xyz1[1],-1*xyz1[2]) ;
		//fr[ϊsɖ߂
		gl.glMatrixMode(GL.GL_MODELVIEW) ;
		//eNX`jbg`p̂̂ɖ߂
		gl.glActiveTexture( textureUnit[textureUnit_number[0]] );
		//VF[_vO̎gp錾
		gl.glUseProgram(shader_pro) ;
		//VF[_ɕϐn
		gl.glUniform1i(gl.glGetUniformLocationARB(shader_pro,"shadowmap"),textureUnit_numberForShadowMap) ;
		for( int i = 0 ; i < textureUnit_number.length ; i++ ) {
			gl.glUniform1i(gl.glGetUniformLocationARB(shader_pro,"texUnit"+textureUnit_number[i]),textureUnit_number[i]) ;
		}
		//
	    light.on() ;

	}
	/**
	 * etf`̌㏈<br>
	 * VF[_vO̎gp~ƃeNX`f̏<br>
	 */
	public void afterDrowSiene() {
		if( shader_pro == -1 ) return ;
		gl.glUseProgram(0) ;
		gl.glMatrixMode(GL.GL_TEXTURE) ;
		gl.glLoadIdentity() ;
	}
	/**
	 * VF[_vÕRpCƃN<br>
	 * @param minimam_shadow	e̍Œᓧx
	 * @throws KGLException				VF[_vÕRpC^ÑG[
	 */
	private void makeShaderProgram(float minimam_shadow) 
	throws KGLException {
		//OIuWFNg̍쐬
		KGLException gle = new KGLException("shader make error") ;
		int[] s_id = new int[2] ;
		int[] lens ;
		String[] Source ;
		//o[ebNXVF[_ƃtOgVF[_̃\[X쐬ƃRpC
		for( int i = 0 ; i < 2 ; i++ ) {
			if( i == 0 ) {
				Source = makeVertexSource(minimam_shadow) ;
				s_id[i] = gl.glCreateShaderObjectARB(GL.GL_VERTEX_SHADER_ARB) ;
			}
			else {
				Source = makeFragmentSource() ;
				s_id[i] = gl.glCreateShaderObjectARB(GL.GL_FRAGMENT_SHADER_ARB) ;
			}
			lens = new int[Source.length] ;
			for( int s = 0 ; s < Source.length ; s++ ) {
				lens[s] = Source[s].length() ;
			}
			gl.glShaderSourceARB(s_id[i],Source.length,Source,lens,0) ;
			gl.glCompileShaderARB(s_id[i]) ;
			setShaderInfoLog(gle,s_id[i]) ;
		}
		//VF[_vO쐬Ao[ebNXVF[_ƃtOgVF[_o^
		shader_pro = gl.glCreateProgramObjectARB() ;
		gl.glAttachObjectARB(shader_pro,s_id[0]) ;
		gl.glAttachObjectARB(shader_pro,s_id[1]) ;
		  
		//o^ς݂̃VF[_ԍ͔j
	 	gl.glDeleteShader(s_id[0]) ;
		gl.glDeleteShader(s_id[1]) ;
		//VF[_vON
		int[] progLinkSuccess = new int[1] ;
		gl.glLinkProgramARB(shader_pro) ;
		gl.glGetObjectParameterivARB(shader_pro, 
		GL.GL_OBJECT_LINK_STATUS_ARB,progLinkSuccess,0); 
		if ( progLinkSuccess[0] == 0 ) 
		{ 
			gle.setMessage("shader could not be linked") ;
			throw gle ;
		}
		//Ƃ肠AVF[_vO͎gp~
		gl.glUseProgram(0) ;

	}
	/**
	 * o[ebNXVF[_̃\[X쐬
	 * @param minimam_shadow	e̍Œᓧx
	 * @return	쐬\[X
	 */
	private String[] makeVertexSource(float minimam_shadow) {
		Vector<String> v_Source = new Vector<String>()  ;
		int lightunit ;
		lightunit = light.getUnit_number() ;
		v_Source.add("varying vec4 shadow;") ;//tOgVF[_ɓnl
		  

		v_Source.add("void main(void)") ;
		v_Source.add("{") ;

		v_Source.add(	"vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);") ;
		v_Source.add(	"vec3 normal = normalize(gl_NormalMatrix * gl_Normal);") ;
		v_Source.add(	"vec3 light = normalize(gl_LightSource["+lightunit+"].position.xyz - position);") ;
		v_Source.add(	"float diffuse = dot(light, normal);") ;
		v_Source.add(	"gl_FrontColor = gl_LightSource["+lightunit+"].ambient * gl_Color;") ;
		v_Source.add(	"shadow = gl_FrontColor;") ;
		v_Source.add(	"if (diffuse > 0.0) {") ;
		v_Source.add(		"vec3 view = normalize(position);") ;
		v_Source.add(		"vec3 halfway = normalize(light - view);") ;
		v_Source.add(		"float specular = pow(max(dot(normal, halfway), 0.0), gl_FrontMaterial.shininess);") ;
		v_Source.add(		"vec4 temp = gl_LightSource["+lightunit+"].diffuse * gl_Color * diffuse;") ;
		v_Source.add(		"shadow += temp * 0.2;") ;
		v_Source.add(		"gl_FrontColor += temp + gl_FrontLightProduct["+lightunit+"].specular * specular ;") ;
		v_Source.add(		"gl_FrontColor.w = gl_Color.w ;") ; // x
		v_Source.add(	"}") ;
		v_Source.add(		"if( shadow.w < "+minimam_shadow+" ) shadow.w = "+minimam_shadow+" ;") ;
		for( int i = 0 ; i < textureUnit_number.length ; i++ ) {
			v_Source.add("gl_TexCoord["+textureUnit_number[i]+"] = gl_MultiTexCoord"+textureUnit_number[i]+" ;") ;
		}
		v_Source.add(	"gl_TexCoord["+textureUnit_numberForShadowMap+"] = gl_TextureMatrix["+textureUnit_numberForShadowMap+"] * gl_ModelViewMatrix * gl_Vertex;") ;
		    //gl_TextureMatrix[???]  ??? = eNX`jbg GL_TEXTURE???
		v_Source.add(	"gl_Position = ftransform();") ;
		v_Source.add("}") ;
		
		
		return v_Source.toArray(new String[0]) ;
	}
	/**
	 * tOgVF[_̃\[X쐬<br>
	 * eNX`̐F̓o[ebNXVF[_ł͎oȂ̂ŁARRŉeƍB
	 * @return	쐬\[X
	 */
	private String[] makeFragmentSource() {
		Vector<String> v_Source = new Vector<String>()  ;
		int lightunit ;
		lightunit = light.getUnit_number() ;
		v_Source.add("uniform sampler2DShadow shadowmap;") ;//OpenGLvO炤l
		for( int t = 0 ; t < textureUnit_number.length ; t++ ) {
		v_Source.add("uniform sampler2D texUnit"+textureUnit_number[t]+";") ;//OpenGLvO炤l
		}
		v_Source.add("varying vec4 shadow;") ;//o[ebNXVF[_炤l
		  
		v_Source.add("void main (void)") ;
		v_Source.add("{") ;
		v_Source.add(	"vec4 wnull = vec4(0,0,0,0);") ;
		v_Source.add(	"vec4 color = vec4(0,0,0,0); ") ;
		v_Source.add(	"int texnum = 0 ; ") ;
		//ifgȂ͈ȉł悳ǂA[x(vec4.wǰvZʂςĂB
//		v_Source.add(	"gl_FragColor = shadow + (gl_Color - shadow) * shadow2DProj(shadowmap, gl_TexCoord["+textureUnit_numberForShadowMap+"]);") ;
		v_Source.add(	"gl_FragColor = gl_Color ;") ;
		v_Source.add(	"if( shadow2DProj(shadowmap, gl_TexCoord["+textureUnit_numberForShadowMap+"]).r == 0.0) {") ;
		v_Source.add(		"gl_FragColor = shadow ;") ;
		v_Source.add(	"}") ;
		for( int t = 0 ; t < textureUnit_number.length ; t++ ) {
			v_Source.add("if( texture2DProj(texUnit"+textureUnit_number[t]+", gl_TexCoord["+textureUnit_number[t]+"]) != wnull ) {") ;
			v_Source.add(	"color += gl_LightSource["+lightunit+"].ambient *texture2DProj(texUnit"+textureUnit_number[t]+", gl_TexCoord["+textureUnit_number[t]+"]) ;") ;
			v_Source.add(	"color += gl_LightSource["+lightunit+"].diffuse *texture2DProj(texUnit"+textureUnit_number[t]+", gl_TexCoord["+textureUnit_number[t]+"]) ;") ;
			v_Source.add(	"texnum ++ ;") ;
			v_Source.add("}") ;
		}
		v_Source.add(	"if( texnum != 0 ) {") ;//eNX`̐O̎͒_̐F̂܂ܕ\̂ŃRȍ~̏͗vȂB
		v_Source.add(		"vec4 cal = vec4(texnum,texnum,texnum,1); ") ;
		v_Source.add(		"gl_FragColor = color/cal; ") ;
		v_Source.add(		"if( shadow2DProj(shadowmap,gl_TexCoord["+textureUnit_numberForShadowMap+"]).r == 0.0 ) {") ;
								//eƒn̐F̊BBBBeLg[ł^^;
		v_Source.add(			"gl_FragColor = gl_FragColor/3 + shadow*2/3 ;") ;
		v_Source.add(		"}") ;
		v_Source.add(	"}") ;
		v_Source.add("}") ;

		
		return v_Source.toArray(new String[0]) ;
	}
	
	/**
	 * VF[_̏Oɏ
	 * @param gle		ݐO
	 * @param shader	ΏۃVF[_ԍ
	 */
	void setShaderInfoLog(KGLException gle,int shader)
	{
		int[] bufSize = new int[1];
		    
		gl.glGetShaderiv(shader, GL.GL_INFO_LOG_LENGTH , bufSize,0);
		    
		if (bufSize[0] > 1) {
			IntBuffer ib = IntBuffer.allocate(1) ;
			ByteBuffer bb = ByteBuffer.allocate(bufSize[0]);
			        
			gl.glGetShaderInfoLog(shader, bufSize[0], ib,bb);
			byte[] bdata = bb.array() ;
			char[] infoLog = new char[bdata.length-1] ;
			for( int i = 0 ; i < infoLog.length ; i++ ) {
				infoLog[i] = (char)bdata[i] ;
			}
			gle.setMessage(infoLog) ;
//			System.out.println(infoLog) ;
		}
	}

}
