/* 
 * PROJECT: NyARToolkit JOGL sample program.
 * --------------------------------------------------------------------------------
 * The MIT License
 * Copyright (c) 2008 nyatla
 * airmail(at)ebony.plala.or.jp
 * http://nyatla.jp/nyartoolkit/
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 */
//package jp.nyatla.nyartoolkit.jogl.sample;
package test; // kei

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener ;
import java.awt.*;
import java.io.File;
import java.util.ArrayList ;
import java.util.TimerTask ;
import java.util.Timer ;

import javax.media.Buffer;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.glu.GLU;

import com.sun.opengl.util.Animator;

import jp.nyatla.nyartoolkit.core.NyARCode;

import jp.nyatla.nyartoolkit.jmf.utils.JmfCameraCapture;
import jp.nyatla.nyartoolkit.jmf.utils.JmfCaptureListener;
import jp.nyatla.nyartoolkit.jogl.utils.*;
import kGLModel.KGLAntiAlias;
import kGLModel.KGLCoordinates_ARToolKit;
import kGLModel.KGLException;
import kGLModel.KGLExtensionCheck;
import kGLModel.KGLLight;
import kGLModel.KGLModelData;
import kGLModel.KGLShadowMapping;
/**
 * simpleLiteƓ悤ȃeXgvO
 * oARToolKit̃TvƎčĂ܂B
 * łv"Hiro"}[J[IāȀɗ̂\܂B
 * 
 */
public class JavaSimpleLite 
implements GLEventListener, JmfCaptureListener, KeyListener
{
	// -------v------ kei add
	// XCb` 
	private final static boolean ON_antiAlias = true ;
	private final static boolean ON_shadow = true ;
	private final static double stateLine = 0.02 ;
	private final static boolean sequence = true ;
//	private final static float modelSize = 0.05f;
//	private final static float modelSize = 0.025f;
	private final static float modelSize = 0.0035f;
	private final static float antiAlias_val = 1f ;

	//σXCb`
	private boolean bAntiAlias = true ;
	private boolean bShadow = true ;
	
	//ff[^
//	 private String filename = "../sachi2/rin-ren.mqo" ;
//	private String filename = "../sachi2/mikuumauma/mikuumauma_0.mqo";
	private String filename = "../sachi2/miku_pose.mqo";
//		private String filename = "../sachi2/miku.mqo";
	// private String filename = "../sachi2/box2.mqo" ;
	// private String filename = "../Data/arrow.mqo" ;
	private KGLModelData model;
	//ff[^iAMQOj
	private String filename_s = "../sachi2/mikuumauma/mikuumauma_";
	private String filename_e = ".mqo";
	private int filename_step = 4;
	private int frame = 0;
	private ArrayList<KGLModelData> models ;
	private Timer frameTimer = null ;
	public class frameControl extends TimerTask {
		Object sync = null;
		public frameControl(Object o) {
			sync = o ;
		}
		public void run() {
			synchronized(sync) {
				try {
					model = models.get(frame) ;
					frame++ ;
				}
				catch(IndexOutOfBoundsException ioobe) {
					frame = 0 ;
					model = models.get(frame) ;
				}
			}
		}
	}


	KGLShadowMapping sm = null;

	KGLLight light = null;
	private KGLAntiAlias al = null;
	private double[]  saveMatrix = null;
	// -----^^^------ kei add

	private final String CARCODE_FILE = "../../Data/patt.hiro";

	private final String PARAM_FILE = "../../Data/camera_para.dat";

	private final static int SCREEN_X = 320;

	private final static int SCREEN_Y = 240;

	private Animator _animator;

	private GLNyARRaster_RGB _cap_image;

	private JmfCameraCapture _capture;

	private GL _gl;

	private NyARGLUtil _glnya;

	//NyARToolkit֌W
	private GLNyARSingleDetectMarker _nya;

	private GLNyARParam _ar_param;

	/**
	 * ̂
	 *
	 */
	void drawCube()
	{
		// Colour cube data.
		int polyList = 0;
		float fSize = 0.5f;//}[J[TCYɑ΂0.5{Ȃ̂ŁA4cm̗
		int f, i;
		float[][] cube_vertices = new float[][] { { 1.0f, 1.0f, 1.0f }, { 1.0f, -1.0f, 1.0f }, { -1.0f, -1.0f, 1.0f }, { -1.0f, 1.0f, 1.0f }, { 1.0f, 1.0f, -1.0f }, { 1.0f, -1.0f, -1.0f }, { -1.0f, -1.0f, -1.0f }, { -1.0f, 1.0f, -1.0f } };
		float[][] cube_vertex_colors = new float[][] { { 1.0f, 1.0f, 1.0f }, { 1.0f, 1.0f, 0.0f }, { 0.0f, 1.0f, 0.0f }, { 0.0f, 1.0f, 1.0f }, { 1.0f, 0.0f, 1.0f }, { 1.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 1.0f } };
		int cube_num_faces = 6;
		short[][] cube_faces = new short[][] { { 3, 2, 1, 0 }, { 2, 3, 7, 6 }, { 0, 1, 5, 4 }, { 3, 0, 4, 7 }, { 1, 2, 6, 5 }, { 4, 5, 6, 7 } };

		if (polyList == 0) {
			polyList = _gl.glGenLists(1);
			_gl.glNewList(polyList, GL.GL_COMPILE);
			_gl.glBegin(GL.GL_QUADS);
			for (f = 0; f < cube_num_faces; f++)
				for (i = 0; i < 4; i++) {
					_gl.glColor3f(cube_vertex_colors[cube_faces[f][i]][0], cube_vertex_colors[cube_faces[f][i]][1], cube_vertex_colors[cube_faces[f][i]][2]);
					_gl.glVertex3f(cube_vertices[cube_faces[f][i]][0] * fSize, cube_vertices[cube_faces[f][i]][1] * fSize, cube_vertices[cube_faces[f][i]][2] * fSize);
				}
			_gl.glEnd();
			_gl.glColor3f(0.0f, 0.0f, 0.0f);
			for (f = 0; f < cube_num_faces; f++) {
				_gl.glBegin(GL.GL_LINE_LOOP);
				for (i = 0; i < 4; i++)
					_gl.glVertex3f(cube_vertices[cube_faces[f][i]][0] * fSize, cube_vertices[cube_faces[f][i]][1] * fSize, cube_vertices[cube_faces[f][i]][2] * fSize);
				_gl.glEnd();
			}
			_gl.glEndList();
		}

		_gl.glPushMatrix(); // Save world coordinate system.
		_gl.glTranslatef(0.0f, 0.0f, 0.5f); // Place base of cube on marker surface.
		_gl.glRotatef(0.0f, 0.0f, 0.0f, 1.0f); // Rotate about z axis.
		_gl.glDisable(GL.GL_LIGHTING); // Just use colours.
		_gl.glCallList(polyList); // Draw the cube.
		_gl.glPopMatrix(); // Restore world coordinate system.

	}

	public JavaSimpleLite()
	{
		Frame frame = new Frame("Java simpleLite with NyARToolkit");

		// 3D`悷R|[lg
//		 GLCanvas canvas = new GLCanvas(); // kei change
		GLCanvas canvas = new GLCanvas(KGLAntiAlias.accumOn(new GLCapabilities()));
		frame.add(canvas);
		frame.addKeyListener(this) ;// kei add
		canvas.addGLEventListener(this);
		canvas.addKeyListener(this) ; // kei add
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		});

		frame.setVisible(true);
		Insets ins = frame.getInsets();
		frame.setSize(SCREEN_X + ins.left + ins.right, SCREEN_Y + ins.top + ins.bottom);
		canvas.setBounds(ins.left, ins.top, SCREEN_X, SCREEN_Y);
	}

	public void init(GLAutoDrawable drawable)
	{
		_gl = drawable.getGL();
		_gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
		// -------v------ kei add
		try {// kei add
			if( ON_antiAlias ) al = new KGLAntiAlias(_gl);
			if( ! sequence ) {
				model = KGLModelData.createGLModel(_gl, null, new File(filename),
						modelSize, new KGLCoordinates_ARToolKit(), true,
						KGLExtensionCheck.IsExtensionSupported(_gl,
								"GL_ARB_vertex_buffer_object"));
				System.out.println("ŏl  " + model.getMinPos().X() + ", "
						+ model.getMinPos().Y() + ", " + model.getMinPos().Z());
				System.out.println("ől  " + model.getMaxPos().X() + ", "
						+ model.getMaxPos().Y() + ", " + model.getMaxPos().Z());
			}
			else {
				boolean bl = true ;
				models = new ArrayList<KGLModelData>() ;
				int namec ;
				namec = 0 ;
				while(bl) {
					try {
						models.add(
								KGLModelData.createGLModel(_gl, null,
										new File(filename_s+namec+filename_e),
										modelSize, new KGLCoordinates_ARToolKit(), true,
										KGLExtensionCheck.IsExtensionSupported(_gl,
												"GL_ARB_vertex_buffer_object"))
								) ;
						namec += filename_step ;
					}
					catch(Exception e) {
						bl = false ;
					}
				}
				model = models.get(0) ;
				frameTimer = new Timer() ;
				frameTimer.schedule(new frameControl(this),10*1000,1000/12) ;
			}
			light = new KGLLight(_gl, GL.GL_LIGHT0, 4.0f, -5.0f, 8.0f, 0.8f,
					0.8f, 0.8f);
			if( ON_shadow ) {
				try {
					sm = new KGLShadowMapping(_gl, new GLU());
	
					sm.init(light, 0, 1, 2048, 2048, 0.5f, false);// Ōboolean
																	// true͂܂ŃfobOp
					// sm = null ;
					// sm.init(light,0,1,320,240,0.5f,true) ;//Ōboolean
					// true͂܂ŃfobOp
				} catch (KGLException ke) {
					System.out.print(ke.getMessage());
					sm = null;
					ke.printStackTrace();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		// -----^^^------ kei add
		//NyARToolkit̏
		try {
			//Lv`̏
			_capture = new JmfCameraCapture(SCREEN_X, SCREEN_Y, 15f, JmfCameraCapture.PIXEL_FORMAT_RGB);
			_capture.setCaptureListener(this);
			//NyARToolkit̏
			_ar_param = new GLNyARParam();
			NyARCode ar_code = new NyARCode(16, 16);
			_ar_param.loadARParamFromFile(PARAM_FILE);
			_ar_param.changeScreenSize(SCREEN_X, SCREEN_Y);
			_nya = new GLNyARSingleDetectMarker(_ar_param, ar_code, 80.0);
			_nya.setContinueMode(false);//trueɂƁAtransMatContinue[hiHistoryvZjɂȂ܂B
			ar_code.loadARPattFromFile(CARCODE_FILE);
			//NyARToolkitp̎xNX
			_glnya = new NyARGLUtil(_gl);
			//GLΉRGBX^IuWFNg
			_cap_image = new GLNyARRaster_RGB(_ar_param);
			//Lv`Jn
			_capture.start();
		} catch (Exception e) {
			e.printStackTrace();
		}
		_animator = new Animator(drawable);

		_animator.start();

	}

	public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height)
	{
		_gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
		_gl.glViewport(0, 0, width, height);

		//̐ς̐ݒ
		_gl.glMatrixMode(GL.GL_PROJECTION);
		_gl.glLoadIdentity();
		//ʒu
		_gl.glMatrixMode(GL.GL_MODELVIEW);
		_gl.glLoadIdentity();
	}

	public void display(GLAutoDrawable drawable)
	{

		try {
			if (!_cap_image.hasData()) {
				return;
			}
			_gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT); // Clear the buffers for new frame.          
			//摜`FbNă}[J[TāAwi
			boolean is_marker_exist;
			synchronized (_cap_image) {
				is_marker_exist = _nya.detectMarkerLite(_cap_image, 110);
				//wi
				_glnya.drawBackGround(_cap_image, 1.0);
			}
			//痧̂
			if (is_marker_exist) {
				// -------v------ kei add
				//Fȕׂ
				boolean ba ;
				boolean bs ;
				ba = bAntiAlias;
				bs = bShadow;
				double[] modelMatrix = null ;
				if(saveMatrix == null ) {
					saveMatrix = new double[16] ;
					System.arraycopy(_nya.getCameraViewRH(),0,saveMatrix,0,16) ;
					modelMatrix = saveMatrix ;
				}
				else {
					modelMatrix = _nya.getCameraViewRH() ;
					int l ;
					for( l = 0 ; l < modelMatrix.length ; l++ ){
						if(stateLine < (modelMatrix[l]-saveMatrix[l] + stateLine/2) ) {
							break ;
						}
					}
					if( modelMatrix.length <= l ) {
						modelMatrix = saveMatrix ;
					}
					else {
						System.arraycopy(_nya.getCameraViewRH(),0,saveMatrix,0,16) ;
					}
				}
				// -----^^^------ kei add
				//}[J[̈vx𒲍Ȃ΁Anya.getConfidence()ňvx𒲂ׂĉB
				// Projection transformation.
				_gl.glMatrixMode(GL.GL_PROJECTION);
				_gl.glLoadMatrixd(_ar_param.getCameraFrustumRH(), 0);
				_gl.glMatrixMode(GL.GL_MODELVIEW);
				// Viewing transformation.
				_gl.glLoadIdentity();
//				_gl.glLoadMatrixd(_nya.getCameraViewRH(), 0);
				_gl.glLoadMatrixd(modelMatrix, 0);

				// All other lighting and geometry goes here.
//				drawCube();
				// -------v------ kei add
				// ̈ʒuĴ
				double[] dd = modelMatrix;
				double[][] dd1 = new double[4][4];
				for (int j = 0; j < 4; j++) {
					for (int i = 0; i < 4; i++) {
						dd1[j][i] = dd[i * 4 + j];
					}
				}
				matrixSelfInv(dd1);
				light.pos.set_XYZ((float) dd1[0][3] - 2.5f, (float) dd1[1][3],
						(float) dd1[2][3]);
				/* */
				int count;
				count = 1;
				if (ba && al != null) {
					al.start(antiAlias_val);
					count = al.getJitterCount();
				}
				for (int c = 0; c < count; c++) {
					if( ba && al != null ) al.jitter(c);
					if (!bs || sm == null) {
						light.on();
						_gl.glEnable(GL.GL_CULL_FACE);
						_gl.glCullFace(GL.GL_BACK);// ʂ\gȂh
						drow();
					} else {
						// shadow map 쐬
						sm.beforeMakeShadowMap(
								(model.getMaxPos().X()-model.getMinPos().X())/2,
								(model.getMaxPos().Y()-model.getMinPos().Y())/2,
								(model.getMaxPos().Z()-model.getMinPos().Z())/2,
								50, 0.5, 0, 0, 1);
						drow();
						// if( true) return ;
						sm.afterMakeShadowMap();
						// shadow map쐬ɉ摜NAĂ̂ŁAĕ`
						_gl.glDisable(GL.GL_CULL_FACE);
						synchronized (_cap_image) {
							_glnya.drawBackGround(_cap_image, 1.0);
						}
						// fobOp shadow mapimage|ɓ\Ă݂
						float floorsize = 1.5f;
						// gl.glActiveTexture( GL.GL_TEXTURE0 );
						if (sm.getShadowMapImage(true) != 0) {
							_gl.glDisable(GL.GL_CULL_FACE);
							_gl.glEnable(GL.GL_TEXTURE_2D);
							_gl.glBindTexture(GL.GL_TEXTURE_2D, sm
									.getShadowMapImage(true));
							// gl.glBindTexture(GL.GL_TEXTURE_2D,fbo.getTextureDepth())
							// ;
							_gl.glEnable(GL.GL_DEPTH_TEST);
							_gl.glEnable(GL.GL_ALPHA_TEST);
							_gl.glEnable(GL.GL_BLEND);
							_gl.glBlendFunc(GL.GL_SRC_ALPHA,
									GL.GL_ONE_MINUS_SRC_ALPHA);
							_gl.glTexEnvf(GL.GL_TEXTURE_ENV,
									GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
							_gl.glColor4f(0.5f, 0.5f, 0.5f, 1.0f);
							_gl.glNormal3i(0, -1, 0);
							_gl.glBegin(GL.GL_QUADS);
							_gl.glTexCoord2f(0, 0);
							_gl.glVertex3f(-1.0f * floorsize + 2, 2, -1.0f
									* floorsize + 1);
							_gl.glTexCoord2f(0, 1);
							_gl.glVertex3f(-1.0f * floorsize + 2, 2,
									1.0f * floorsize + 1);
							_gl.glTexCoord2f(1, 1);
							_gl.glVertex3f(1.0f * floorsize + 2, 2,
									1.0f * floorsize + 1);
							_gl.glTexCoord2f(1, 0);
							_gl.glVertex3f(1.0f * floorsize + 2, 2, -1.0f
									* floorsize + 1);
							_gl.glEnd();
						}

						// etf`
						sm.beforeDrowSiene();
						drow();
						sm.afterDrowSiene();
					}
					if( ba && al != null ) al.add();
				}
				if( ba && al != null ) {
					_gl.glClear(GL.GL_COLOR_BUFFER_BIT); // 
					al.flush();
				}
				/* */
				// -----^^^------ kei add
			}
			Thread.sleep(1);//^XNsUn
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
	public void onUpdateBuffer(Buffer i_buffer)
	{
		try {
			synchronized (_cap_image) {
				_cap_image.setBuffer(i_buffer, true);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged)
	{
	}

	public static void main(String[] args)
	{
		new JavaSimpleLite();
	}
	// -------v------ kei add
	private void drow() {
		float floorsize = 12.0f;
		_gl.glDisable(GL.GL_CULL_FACE);
		_gl.glEnable(GL.GL_DEPTH_TEST);
		_gl.glEnable(GL.GL_ALPHA_TEST);
		_gl.glEnable(GL.GL_BLEND);
		_gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
		_gl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
		// float[] fw = new float[4] ;
		// fw[0] = fw[1] = fw[2] = fw[3] = 0.0f;
		// fw[3] = 0.0f ;
		// gl.glColor4f(0.0f,0.0f,0.0f,0.0f) ;
		// gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_DIFFUSE,fw,0) ;
		// fw[0] = fw[1] = fw[2] = fw[3] = 0.0f;
		// fw[3] = 0.0f ;
		// gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_AMBIENT,fw,0) ;
		float[] fw = new float[4];
		fw[0] = fw[1] = fw[2] = fw[3] = 1.0f;
		_gl.glColor4f(0.0f, 1.0f, 1.0f, 0.0f);
		fw[3] = 0.0f;
		_gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_DIFFUSE, fw, 0);
		_gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT, fw, 0);
		_gl.glDisable(GL.GL_TEXTURE_2D);
		_gl.glNormal3i(0, 0, 1);
		_gl.glBegin(GL.GL_QUADS);
		_gl.glVertex3f(-1.0f * floorsize, -1.0f * floorsize, 0);
		_gl.glVertex3f(-1.0f * floorsize, 1.0f * floorsize, 0);
		_gl.glVertex3f(1.0f * floorsize, 1.0f * floorsize, 0);
		_gl.glVertex3f(1.0f * floorsize, -1.0f * floorsize, 0);
		_gl.glEnd();
		_gl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_MODULATE);
		_gl.glEnable(GL.GL_CULL_FACE);
		_gl.glCullFace(GL.GL_BACK);
		// gl.glTranslatef(0,0,-1.5f) ;
		synchronized(this) {
			model.enables(1.0f);
			model.draw();
			model.disables();
		}
	}
	// NyARMat̎g悭킩Ȃ̂ŁAvZoB
	public void matrixSelfInv(double[][] m) throws Exception {
		double[][] ap = m;
		int dimen = m.length;
		int dimen_1 = dimen - 1;
		double[] ap_n, ap_ip, ap_i;// wap;
		int j, ip, nwork;
		int[] nos = new int[50];// ̊֐ŏB
		// double epsl;
		double p, pbuf, work;

		// epsl = 1.0e-10; /* Threshold value */
		/* check size */
		switch (dimen) {
		case 0:
			throw new Exception();
		case 1:
			ap[0][0] = 1.0 / ap[0][0];// *ap = 1.0 / (*ap);
			return;/* 1 dimension */
		}

		for (int n = 0; n < dimen; n++) {
			nos[n] = n;
		}

		/*
		 * nyatla memo ip܂ȂŌvZsꍇ̂ő}B [v0ĂȂB
		 */
		ip = 0;
		// int wap_ptr,wbp_ptr;
		// ForύX֎~
		for (int n = 0; n < dimen; n++) {
			ap_n = ap[n];// wcp = ap + n * rowa;
			p = 0.0;
			// wap_ptr=0;//wap = DoublePointer.wrap(wcp);
			for (int i = n; i < dimen; i++) {// for(i = n, wap = wcp, p =
												// 0.0; i < dimen ; i++, wap +=
												// rowa)
			// wap=ap[i];
				if (p < (pbuf = Math.abs(ap[i][0]))) {
					p = pbuf;
					ip = i;
				}
			}
			if (p <= (1.0e-10)) {
				return;
			}

			nwork = nos[ip];
			nos[ip] = nos[n];
			nos[n] = nwork;

			ap_ip = ap[ip];
			// wbp=ap_n;
			// wap_ptr=0;
			// wbp_ptr=0;
			for (j = 0; j < dimen; j++) {// for(j = 0, wap = ap + ip * rowa,
											// wbp = wcp; j < dimen ; j++) {
				work = ap_ip[j]; // work = *wap;
				ap_ip[j] = ap_n[j];
				// wap_ptr++;//*wap++ = *wbp;
				ap_n[j] = work;
				// wbp_ptr++; //*wbp++ = work;
			}

			// wap=ap_n;
			// wap_ptr=0;
			work = ap_n[0];
			for (j = 0; j < dimen_1; j++) {// for(j = 1, wap = wcp, work =
											// *wcp; j < dimen ; j++, wap++)
				ap_n[j] = ap_n[j + 1] / work;// *wap = *(wap + 1) / work;
				// wap_ptr++;
			}
			ap_n[j] = 1.0 / work;// *wap = 1.0 / work;
			// wbp=ap_n;
			for (int i = 0; i < dimen; i++) {
				if (i != n) {
					ap_i = ap[i];// wap = ap + i * rowa;

					// wap_ptr=0;
					// wbp_ptr=0;
					work = ap_i[0];
					for (j = 0; j < dimen_1; j++) {// for(j = 1, wbp = wcp,
													// work = *wap;j < dimen ;
													// j++, wap++, wbp++)
						ap_i[j] = ap_i[j + 1] - work * ap_n[j];// wap = *(wap +
																// 1) - work *
																// (*wbp);
						// wap_ptr++;
						// wbp_ptr++;
					}
					ap_i[j] = -work * ap_n[j];// *wap = -work * (*wbp);
				}
			}
		}

		for (int n = 0; n < dimen; n++) {
			for (j = n; j < dimen; j++) {
				if (nos[j] == n) {
					break;
				}
			}
			nos[j] = nos[n];
			for (int i = 0; i < dimen; i++) {// for(i = 0, wap = ap + j, wbp
												// = ap + n; i < dimen ;i++, wap
												// += rowa, wbp += rowa) {
				ap_i = ap[i];
				// wbp=ap[i];
				work = ap_i[j];// work = *wap;
				ap_i[j] = ap_i[n];// *wap = *wbp;
				ap_i[n] = work;// *wbp = work;
			}
		}
		return;
	}
	// KeyListener
	public void keyPressed(KeyEvent e) {
		
	}
	public void keyReleased(KeyEvent e) {
		switch(e.getKeyCode()) {
		case KeyEvent.VK_A :
			bAntiAlias = !bAntiAlias;
			break ;
		case KeyEvent.VK_S :
			bShadow = !bShadow ;
			break ;
		case KeyEvent.VK_ESCAPE :
			System.exit(0);
			break ;
		}
	}
	public void keyTyped(KeyEvent e) {
		
	}
	// -----^^^------ kei add
}
